Index: protocols/http_client.h
===================================================================
--- protocols/http_client.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/http_client.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -0,0 +1,54 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2005 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* HTTP(S) module                                                       */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include <glib.h>
+
+#include "ssl_client.h"
+
+struct http_request;
+
+typedef void (*http_input_function)( struct http_request * );
+
+struct http_request
+{
+	char *request;
+	int request_length;
+	int status_code;
+	char *reply_headers;
+	char *reply_body;
+	int finished;
+	
+	void *ssl;
+	int fd;
+	
+	int inpa;
+	int bytes_written;
+	int bytes_read;
+	
+	http_input_function func;
+	gpointer data;
+};
+
+void *http_dorequest( char *host, int port, int ssl, char *request, http_input_function func, gpointer data );
Index: protocols/jabber/Makefile
===================================================================
--- protocols/jabber/Makefile	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/jabber/Makefile	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -16,5 +16,5 @@
 
 # [SH] Phony targets
-all: jabberr.o
+all: jabber_mod.o
 
 .PHONY: all clean distclean
@@ -33,5 +33,5 @@
 	@$(CC) -c $(CFLAGS) $< -o $@
 
-jabberr.o: $(objects)
-	@echo '*' Linking jabberr.o
-	@$(LD) $(LFLAGS) $(objects) -o jabberr.o
+jabber_mod.o: $(objects)
+	@echo '*' Linking jabber_mod.o
+	@$(LD) $(LFLAGS) $(objects) -o jabber_mod.o
Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/jabber/jabber.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -1249,12 +1249,8 @@
 			gjab_auth(gjc);
 		} else {
+			gjab_reqroster(gjc);
 			account_online(GJ_GC(gjc));
-
-			if (bud_list_cache_exists(GJ_GC(gjc)))
-				do_import(GJ_GC(gjc), NULL);
-
+			
 			((struct jabber_data *)GJ_GC(gjc)->proto_data)->did_import = TRUE;
-
-			gjab_reqroster(gjc);
 		}
 	} else {
@@ -1860,9 +1856,5 @@
 			xmlnode_insert_cdata(y, "away", -1);
 			y = xmlnode_insert_tag(x, "status");
-			{
-				char *utf8 = str_to_utf8(message);
-				xmlnode_insert_cdata(y, utf8, -1);
-				g_free(utf8);
-			}
+			xmlnode_insert_cdata(y, message, -1);
 			gc->away = "";
 		} else {
Index: protocols/msn/Makefile
===================================================================
--- protocols/msn/Makefile	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/msn/Makefile	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -16,5 +16,5 @@
 
 # [SH] Phony targets
-all: msnn.o
+all: msn_mod.o
 	
 .PHONY: all clean distclean
@@ -33,7 +33,7 @@
 	@$(CC) -c $(CFLAGS) $< -o $@
 
-msnn.o: $(objects)
-	@echo '*' Linking msnn.o
-	@$(LD) $(LFLAGS) $(objects) -o msnn.o
+msn_mod.o: $(objects)
+	@echo '*' Linking msn_mod.o
+	@$(LD) $(LFLAGS) $(objects) -o msn_mod.o
 	
 
Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/msn/msn.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -170,5 +170,5 @@
 	
 	for( i = 0; msn_away_state_list[i].number > -1; i ++ )
-		l = g_list_append( l, msn_away_state_list[i].name );
+		l = g_list_append( l, (void*) msn_away_state_list[i].name );
 	
 	return( l );
@@ -177,8 +177,8 @@
 static char *msn_get_status_string( struct gaim_connection *gc, int number )
 {
-	struct msn_away_state *st = msn_away_state_by_number( number );
+	const struct msn_away_state *st = msn_away_state_by_number( number );
 	
 	if( st )
-		return( st->name );
+		return( (char*) st->name );
 	else
 		return( "" );
@@ -189,5 +189,5 @@
 	char buf[1024];
 	struct msn_data *md = gc->proto_data;
-	struct msn_away_state *st;
+	const struct msn_away_state *st;
 	
 	if( strcmp( state, GAIM_AWAY_CUSTOM ) == 0 )
Index: protocols/msn/msn.h
===================================================================
--- protocols/msn/msn.h	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/msn/msn.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -67,5 +67,5 @@
 	GSList *switchboards;
 	int buddycount;
-	struct msn_away_state *away_state;
+	const struct msn_away_state *away_state;
 };
 
@@ -127,8 +127,10 @@
 #define STATUS_FATAL            1
 #define STATUS_SB_FATAL         2
+#define STATUS_SB_IM_SPARE	4	/* Make one-to-one conversation switchboard available again, invite failed. */
+#define STATUS_SB_CHAT_SPARE	8	/* Same, but also for groupchats (not used yet). */
 
 int msn_chat_id;
-extern struct msn_away_state msn_away_state_list[];
-extern struct msn_status_code msn_status_code_list[];
+extern const struct msn_away_state msn_away_state_list[];
+extern const struct msn_status_code msn_status_code_list[];
 
 /* Keep a list of all the active connections. We need these lists because
@@ -154,8 +156,8 @@
 
 /* tables.c */
-struct msn_away_state *msn_away_state_by_number( int number );
-struct msn_away_state *msn_away_state_by_code( char *code );
-struct msn_away_state *msn_away_state_by_name( char *name );
-struct msn_status_code *msn_status_by_number( int number );
+const struct msn_away_state *msn_away_state_by_number( int number );
+const struct msn_away_state *msn_away_state_by_code( char *code );
+const struct msn_away_state *msn_away_state_by_name( char *name );
+const struct msn_status_code *msn_status_by_number( int number );
 
 /* sb.c */
Index: protocols/msn/ns.c
===================================================================
--- protocols/msn/ns.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/msn/ns.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -208,5 +208,5 @@
 		{
 			/* Time for some Passport black magic... */
-			if( !passport_get_id( gc, gc->username, gc->password, cmd[4], msn_auth_got_passport_id ) )
+			if( !passport_get_id( msn_auth_got_passport_id, gc, gc->username, gc->password, cmd[4] ) )
 			{
 				hide_login_progress_error( gc, "Error while contacting Passport server" );
@@ -365,5 +365,5 @@
 	else if( strcmp( cmd[0], "ILN" ) == 0 )
 	{
-		struct msn_away_state *st;
+		const struct msn_away_state *st;
 		
 		if( num_parts != 6 )
@@ -393,5 +393,5 @@
 	else if( strcmp( cmd[0], "NLN" ) == 0 )
 	{
-		struct msn_away_state *st;
+		const struct msn_away_state *st;
 		
 		if( num_parts != 5 )
@@ -539,5 +539,5 @@
 	{
 		int num = atoi( cmd[0] );
-		struct msn_status_code *err = msn_status_by_number( num );
+		const struct msn_status_code *err = msn_status_by_number( num );
 		
 		g_snprintf( buf, sizeof( buf ), "Error reported by MSN server: %s", err->text );
Index: protocols/msn/passport.c
===================================================================
--- protocols/msn/passport.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/msn/passport.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -20,5 +20,5 @@
  */
 
-#include "ssl_client.h"
+#include "http_client.h"
 #include "passport.h"
 #include "msn.h"
@@ -31,259 +31,72 @@
 static char *prd_cached = NULL;
 
-static char *passport_create_header( char *reply, char *email, char *pwd );
+static int passport_get_id_real( gpointer func, gpointer data, char *header );
+static void passport_get_id_ready( struct http_request *req );
+
 static int passport_retrieve_dalogin( gpointer data, gpointer func, char *header );
-static void passport_retrieve_dalogin_connected( gpointer data, void *ssl, GaimInputCondition cond );
-static int passport_get_id_from( gpointer data, gpointer func, char *header_i, char *url );
-static void passport_get_id_connected( gpointer data, void *ssl, GaimInputCondition cond );
+static void passport_retrieve_dalogin_ready( struct http_request *req );
+
+static char *passport_create_header( char *cookie, char *email, char *pwd );
 static void destroy_reply( struct passport_reply *rep );
 
-
-int passport_get_id( gpointer data, char *username, char *password, char *cookie, gpointer func )
+int passport_get_id( gpointer func, gpointer data, char *username, char *password, char *cookie )
 {
 	char *header = passport_create_header( cookie, username, password );
 	
-	if( prd_cached )
-	{
-		int st;
-		
-		st = passport_get_id_from( data, func, header, prd_cached );
-		g_free( header );
-		return( st );
-	}
+	if( prd_cached == NULL )
+		return passport_retrieve_dalogin( func, data, header );
 	else
-	{
-		return( passport_retrieve_dalogin( data, func, header ) );
-	}
-}
-
-
-static char *passport_create_header( char *reply, char *email, char *pwd )
-{
-	char *buffer = g_new0( char, 2048 );
-	char *currenttoken;
-	char *email_enc, *pwd_enc;
-	
-	email_enc = g_new0( char, strlen( email ) * 3 + 1 );
-	strcpy( email_enc, email );
-	http_encode( email_enc );
-	
-	pwd_enc = g_new0( char, strlen( pwd ) * 3 + 1 );
-	strcpy( pwd_enc, pwd );
-	http_encode( pwd_enc );
-	
-	currenttoken = strstr( reply, "lc=" );
-	if( currenttoken == NULL )
-		return( NULL );
-	
-	g_snprintf( buffer, 2048,
-	            "Authorization: Passport1.4 OrgVerb=GET,"
-	            "OrgURL=http%%3A%%2F%%2Fmessenger%%2Emsn%%2Ecom,"
-	            "sign-in=%s,pwd=%s,%s", email_enc, pwd_enc,
-	            currenttoken );
-	
-	g_free( email_enc );
-	g_free( pwd_enc );
-	
-	return( buffer );
-}
-
-
-static int passport_retrieve_dalogin( gpointer data, gpointer func, char *header )
-{
-	struct passport_reply *rep = g_new0( struct passport_reply, 1 );
-	void *ssl;
-	
+		return passport_get_id_real( func, data, header );
+}
+
+static int passport_get_id_real( gpointer func, gpointer data, char *header )
+{
+	struct passport_reply *rep;
+	char *server, *dummy, *reqs;
+	struct http_request *req;
+	
+	rep = g_new0( struct passport_reply, 1 );
 	rep->data = data;
 	rep->func = func;
-	rep->header = header;
-	
-	ssl = ssl_connect( "nexus.passport.com", 443, passport_retrieve_dalogin_connected, rep );
-	
-	if( !ssl )
-		destroy_reply( rep );
-	
-	return( ssl != NULL );
-}
-
-#define PPR_BUFFERSIZE 2048
-#define PPR_REQUEST "GET /rdr/pprdr.asp HTTP/1.0\r\n\r\n"
-static void passport_retrieve_dalogin_connected( gpointer data, void *ssl, GaimInputCondition cond )
-{
-	int ret;
-	char buffer[PPR_BUFFERSIZE+1];
-	struct passport_reply *rep = data;
-	
-	if( !g_slist_find( msn_connections, rep->data ) )
-	{
-		if( ssl ) ssl_disconnect( ssl );
+	
+	server = g_strdup( prd_cached );
+	dummy = strchr( server, '/' );
+	
+	if( dummy == NULL )
+	{
+		destroy_reply( rep );
+		return( 0 );
+	}
+	
+	reqs = g_malloc( strlen( header ) + strlen( dummy ) + 128 );
+	sprintf( reqs, "GET %s HTTP/1.0\r\n%s\r\n\r\n", dummy, header );
+	
+	*dummy = 0;
+	req = http_dorequest( server, 443, 1, reqs, passport_get_id_ready, rep );
+	
+	g_free( server );
+	g_free( reqs );
+	
+	if( req == NULL )
+		destroy_reply( rep );
+	
+	return( req != NULL );
+}
+
+static void passport_get_id_ready( struct http_request *req )
+{
+	struct passport_reply *rep = req->data;
+	
+	if( !g_slist_find( msn_connections, rep->data ) || !req->finished || !req->reply_headers )
+	{
 		destroy_reply( rep );
 		return;
 	}
 	
-	if( !ssl )
-	{
-		rep->func( rep );
-		destroy_reply( rep );
-		return;
-	}
-	
-	ssl_write( ssl, PPR_REQUEST, strlen( PPR_REQUEST ) );
-	
-	if( ( ret = ssl_read( ssl, buffer, PPR_BUFFERSIZE ) ) <= 0 )
-	{
-		goto failure;
-	}
-
-	{
-		char *dalogin = strstr( buffer, "DALogin=" );
-		char *urlend;
+	if( req->status_code == 200 )
+	{
+		char *dummy;
 		
-		if( !dalogin )
-			goto failure;
-		
-		dalogin += strlen( "DALogin=" );
-		urlend = strchr( dalogin, ',' );
-		if( urlend )
-			*urlend = 0;
-		
-		/* strip the http(s):// part from the url */
-		urlend = strstr( urlend, "://" );
-		if( urlend )
-			dalogin = urlend + strlen( "://" );
-		
-		if( prd_cached == NULL )
-			prd_cached = g_strdup( dalogin );
-	}
-	
-	if( passport_get_id_from( rep->data, rep->func, rep->header, prd_cached ) )
-	{
-		ssl_disconnect( ssl );
-		destroy_reply( rep );
-		return;
-	}
-	
-failure:	
-	ssl_disconnect( ssl );
-	rep->func( rep );
-	destroy_reply( rep );
-}
-
-
-static int passport_get_id_from( gpointer data, gpointer func, char *header_i, char *url )
-{
-	struct passport_reply *rep = g_new0( struct passport_reply, 1 );
-	char server[512], *dummy;
-	void *ssl;
-	
-	rep->data = data;
-	rep->func = func;
-	rep->redirects = 4;
-	
-	strncpy( server, url, 512 );
-	dummy = strchr( server, '/' );
-	if( dummy )
-		*dummy = 0;
-	
-	ssl = ssl_connect( server, 443, passport_get_id_connected, rep );
-	
-	if( ssl )
-	{
-		rep->header = g_strdup( header_i );
-		rep->url = g_strdup( url );
-	}
-	else
-	{
-		destroy_reply( rep );
-	}
-	
-	return( ssl != NULL );
-}
-
-#define PPG_BUFFERSIZE 4096
-static void passport_get_id_connected( gpointer data, void *ssl, GaimInputCondition cond )
-{
-	struct passport_reply *rep = data;
-	char server[512], buffer[PPG_BUFFERSIZE+1], *dummy;
-	int ret;
-	
-	if( !g_slist_find( msn_connections, rep->data ) )
-	{
-		if( ssl ) ssl_disconnect( ssl );
-		destroy_reply( rep );
-		return;
-	}
-	
-	if( !ssl )
-	{
-		rep->func( rep );
-		destroy_reply( rep );
-		return;
-	}
-	
-	memset( buffer, 0, PPG_BUFFERSIZE + 1 );
-	
-	strncpy( server, rep->url, 512 );
-	dummy = strchr( server, '/' );
-	if( dummy == NULL )
-		goto end;
-	
-	g_snprintf( buffer, PPG_BUFFERSIZE - 1, "GET %s HTTP/1.0\r\n"
-	            "%s\r\n\r\n", dummy, rep->header );
-	
-	ssl_write( ssl, buffer, strlen( buffer ) );
-	memset( buffer, 0, PPG_BUFFERSIZE + 1 );
-	
-	{
-		char *buffer2 = buffer;
-		
-		while( ( ( ret = ssl_read( ssl, buffer2, 512 ) ) > 0 ) &&
-		       ( buffer + PPG_BUFFERSIZE - buffer2 - ret - 512 >= 0 ) )
-		{
-			buffer2 += ret;
-		}
-	}
-	
-	if( *buffer == 0 )
-		goto end;
-	
-	if( ( dummy = strstr( buffer, "Location:" ) ) )
-	{
-		char *urlend;
-		
-		rep->redirects --;
-		if( rep->redirects == 0 )
-			goto end;
-		
-		dummy += strlen( "Location:" );
-		while( isspace( *dummy ) ) dummy ++;
-		urlend = dummy;
-		while( !isspace( *urlend ) ) urlend ++;
-		*urlend = 0;
-		if( ( urlend = strstr( dummy, "://" ) ) )
-			dummy = urlend + strlen( "://" );
-		
-		g_free( rep->url );
-		rep->url = g_strdup( dummy );
-		
-		strncpy( server, dummy, sizeof( server ) - 1 );
-		dummy = strchr( server, '/' );
-		if( dummy ) *dummy = 0;
-		
-		ssl_disconnect( ssl );
-		
-		if( ssl_connect( server, 443, passport_get_id_connected, rep ) )
-		{
-			return;
-		}
-		else
-		{
-			rep->func( rep );
-			destroy_reply( rep );
-			return;
-		}
-	}
-	else if( strstr( buffer, "200 OK" ) )
-	{
-		if( ( dummy = strstr( buffer, "from-PP='" ) ) )
+		if( ( dummy = strstr( req->reply_headers, "from-PP='" ) ) )
 		{
 			char *responseend;
@@ -298,16 +111,101 @@
 	}
 	
-end:
-	ssl_disconnect( ssl );
 	rep->func( rep );
 	destroy_reply( rep );
 }
 
+static char *passport_create_header( char *cookie, char *email, char *pwd )
+{
+	char *buffer = g_new0( char, 2048 );
+	char *currenttoken;
+	char *email_enc, *pwd_enc;
+	
+	email_enc = g_new0( char, strlen( email ) * 3 + 1 );
+	strcpy( email_enc, email );
+	http_encode( email_enc );
+	
+	pwd_enc = g_new0( char, strlen( pwd ) * 3 + 1 );
+	strcpy( pwd_enc, pwd );
+	http_encode( pwd_enc );
+	
+	currenttoken = strstr( cookie, "lc=" );
+	if( currenttoken == NULL )
+		return( NULL );
+	
+	g_snprintf( buffer, 2048,
+	            "Authorization: Passport1.4 OrgVerb=GET,"
+	            "OrgURL=http%%3A%%2F%%2Fmessenger%%2Emsn%%2Ecom,"
+	            "sign-in=%s,pwd=%s,%s", email_enc, pwd_enc,
+	            currenttoken );
+	
+	g_free( email_enc );
+	g_free( pwd_enc );
+	
+	return( buffer );
+}
+
+#define PPR_REQUEST "GET /rdr/pprdr.asp HTTP/1.0\r\n\r\n"
+static int passport_retrieve_dalogin( gpointer func, gpointer data, char *header )
+{
+	struct passport_reply *rep = g_new0( struct passport_reply, 1 );
+	struct http_request *req;
+	
+	rep->data = data;
+	rep->func = func;
+	rep->header = header;
+	
+	req = http_dorequest( "nexus.passport.com", 443, 1, PPR_REQUEST, passport_retrieve_dalogin_ready, rep );
+	
+	if( !req )
+		destroy_reply( rep );
+	
+	return( req != NULL );
+}
+
+static void passport_retrieve_dalogin_ready( struct http_request *req )
+{
+	struct passport_reply *rep = req->data;
+	char *dalogin;
+	char *urlend;
+	
+	if( !g_slist_find( msn_connections, rep->data ) || !req->finished || !req->reply_headers )
+	{
+		destroy_reply( rep );
+		return;
+	}
+	
+	dalogin = strstr( req->reply_headers, "DALogin=" );	
+	
+	if( !dalogin )
+		goto failure;
+	
+	dalogin += strlen( "DALogin=" );
+	urlend = strchr( dalogin, ',' );
+	if( urlend )
+		*urlend = 0;
+	
+	/* strip the http(s):// part from the url */
+	urlend = strstr( urlend, "://" );
+	if( urlend )
+		dalogin = urlend + strlen( "://" );
+	
+	if( prd_cached == NULL )
+		prd_cached = g_strdup( dalogin );
+	
+	if( passport_get_id_real( rep->func, rep->data, rep->header ) )
+	{
+		destroy_reply( rep );
+		return;
+	}
+	
+failure:	
+	rep->func( rep );
+	destroy_reply( rep );
+}
 
 static void destroy_reply( struct passport_reply *rep )
 {
-	if( rep->result ) g_free( rep->result );
-	if( rep->url ) g_free( rep->url );
-	if( rep->header ) g_free( rep->header );
-	if( rep ) g_free( rep );
-}
+	g_free( rep->result );
+	g_free( rep->header );
+	g_free( rep );
+}
Index: protocols/msn/passport.h
===================================================================
--- protocols/msn/passport.h	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/msn/passport.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -35,13 +35,11 @@
 struct passport_reply
 {
+	void (*func)( struct passport_reply * );
 	void *data;
 	char *result;
-	void (*func)( struct passport_reply * );
-	char *url;
 	char *header;
-	int redirects;
 };
 
-int passport_get_id( gpointer data, char *username, char *password, char *cookie, gpointer func );
+int passport_get_id( gpointer func, gpointer data, char *username, char *password, char *cookie );
 
 #endif /* __PASSPORT_H__ */
Index: protocols/msn/sb.c
===================================================================
--- protocols/msn/sb.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/msn/sb.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -512,5 +512,5 @@
 	{
 		int num = atoi( cmd[0] );
-		struct msn_status_code *err = msn_status_by_number( num );
+		const struct msn_status_code *err = msn_status_by_number( num );
 		
 		g_snprintf( buf, sizeof( buf ), "Error reported by switchboard server: %s", err->text );
@@ -522,8 +522,32 @@
 			return( 0 );
 		}
-		else if( err->flags & STATUS_FATAL )
+		if( err->flags & STATUS_FATAL )
 		{
 			signoff( gc );
 			return( 0 );
+		}
+		if( err->flags & STATUS_SB_IM_SPARE )
+		{
+			if( sb->who )
+			{
+				struct msn_message *m;
+				GSList *l;
+				
+				/* Apparently some invitation failed. We might want to use this
+				   board later, so keep it as a spare. */
+				g_free( sb->who );
+				sb->who = NULL;
+				
+				/* Also clear the msgq, otherwise someone else might get them. */
+				for( l = sb->msgq; l; l = l->next )
+				{
+					m = l->data;
+					g_free( m->who );
+					g_free( m->text );
+					g_free( m );
+				}
+				g_slist_free( sb->msgq );
+				sb->msgq = NULL;
+			}
 		}
 	}
Index: protocols/msn/tables.c
===================================================================
--- protocols/msn/tables.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/msn/tables.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -27,5 +27,5 @@
 #include "msn.h"
 
-struct msn_away_state msn_away_state_list[] =
+const struct msn_away_state msn_away_state_list[] =
 {
 	{  0, "NLN", "Available" },
@@ -40,5 +40,5 @@
 };
 
-struct msn_away_state *msn_away_state_by_number( int number )
+const struct msn_away_state *msn_away_state_by_number( int number )
 {
 	int i;
@@ -51,5 +51,5 @@
 }
 
-struct msn_away_state *msn_away_state_by_code( char *code )
+const struct msn_away_state *msn_away_state_by_code( char *code )
 {
 	int i;
@@ -62,5 +62,5 @@
 }
 
-struct msn_away_state *msn_away_state_by_name( char *name )
+const struct msn_away_state *msn_away_state_by_name( char *name )
 {
 	int i;
@@ -73,5 +73,5 @@
 }
 
-struct msn_status_code msn_status_code_list[] =
+const struct msn_status_code msn_status_code_list[] =
 {
 	{ 200, "Invalid syntax",                                        0 },
@@ -80,10 +80,10 @@
 	{ 206, "Domain name missing",                                   0 },
 	{ 207, "Already logged in",                                     0 },
-	{ 208, "Invalid handle",                                        0 },
+	{ 208, "Invalid handle",                                        STATUS_SB_IM_SPARE },
 	{ 209, "Forbidden nickname",                                    0 },
 	{ 210, "Buddy list too long",                                   0 },
 	{ 215, "Handle is already in list",                             0 },
-	{ 216, "Handle is not in list",                                 0 },
-	{ 217, "Person is off-line or non-existent",                    0 },
+	{ 216, "Handle is not in list",                                 STATUS_SB_IM_SPARE },
+	{ 217, "Person is off-line or non-existent",                    STATUS_SB_IM_SPARE },
 	{ 218, "Already in that mode",                                  0 },
 	{ 219, "Handle is already in opposite list",                    0 },
@@ -118,5 +118,5 @@
 	{ 711, "Write is blocking",                                     STATUS_FATAL },
 	{ 712, "Session is overloaded",                                 STATUS_FATAL },
-	{ 713, "Calling too rapidly",                                   0 },
+	{ 713, "Calling too rapidly",                                   STATUS_SB_IM_SPARE },
 	{ 714, "Too many sessions",                                     STATUS_FATAL },
 	{ 715, "Not expected/Invalid argument/action",                  0 },
@@ -144,5 +144,5 @@
 };
 
-struct msn_status_code *msn_status_by_number( int number )
+const struct msn_status_code *msn_status_by_number( int number )
 {
 	static struct msn_status_code *unknown = NULL;
Index: protocols/nogaim.h
===================================================================
--- protocols/nogaim.h	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/nogaim.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -312,9 +312,6 @@
 G_MODULE_EXPORT void serv_got_chat_in( struct gaim_connection *gc, int id, char *who, int whisper, char *msg, time_t mtime );
 G_MODULE_EXPORT void serv_got_chat_left( struct gaim_connection *gc, int id );
-/* void serv_finish_login( struct gaim_connection *gc ); */
 
 /* util.c */
-G_MODULE_EXPORT char *utf8_to_str( const char *in );
-G_MODULE_EXPORT char *str_to_utf8( const char *in );
 G_MODULE_EXPORT void strip_linefeed( gchar *text );
 G_MODULE_EXPORT char *add_cr( char *text );
@@ -323,6 +320,8 @@
 G_MODULE_EXPORT time_t get_time( int year, int month, int day, int hour, int min, int sec );
 G_MODULE_EXPORT void strip_html( char *msg );
-G_MODULE_EXPORT char * escape_html(const char *html);
+G_MODULE_EXPORT char *escape_html( const char *html );
 G_MODULE_EXPORT void info_string_append(GString *str, char *newline, char *name, char *value);
+G_MODULE_EXPORT char *ipv6_wrap( char *src );
+G_MODULE_EXPORT char *ipv6_unwrap( char *src );
 
 /* prefs.c */
Index: protocols/oscar/Makefile
===================================================================
--- protocols/oscar/Makefile	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/oscar/Makefile	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -16,5 +16,5 @@
 
 # [SH] Phony targets
-all: oscarr.o
+all: oscar_mod.o
 
 .PHONY: all clean distclean
@@ -33,5 +33,5 @@
 	@$(CC) -c $(CFLAGS) $< -o $@
 
-oscarr.o: $(objects)
-	@echo '*' Linking oscarr.o
-	@$(LD) $(LFLAGS) $(objects) -o oscarr.o
+oscar_mod.o: $(objects)
+	@echo '*' Linking oscar_mod.o
+	@$(LD) $(LFLAGS) $(objects) -o oscar_mod.o
Index: protocols/proxy.c
===================================================================
--- protocols/proxy.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/proxy.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -106,6 +106,4 @@
 	if (condition & GAIM_WRITE_COND)
 		gaim_cond |= GAIM_INPUT_WRITE;
-//	if (condition & GAIM_ERR_COND)
-//		fprintf( stderr, "ERROR! fd=%d\n", g_io_channel_unix_get_fd( source ) );
 
 	closure->function(closure->data, g_io_channel_unix_get_fd(source), gaim_cond);
Index: protocols/ssl_bogus.c
===================================================================
--- protocols/ssl_bogus.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/ssl_bogus.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -28,5 +28,5 @@
 int ssl_errno;
 
-void *ssl_connect( char *host, int port, SslInputFunction func, gpointer data )
+void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data )
 {
 	return( NULL );
@@ -51,2 +51,7 @@
 	return( -1 );
 }
+
+GaimInputCondition ssl_getdirection( void *conn )
+{
+	return GAIM_INPUT_READ;
+}
Index: protocols/ssl_client.h
===================================================================
--- protocols/ssl_client.h	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/ssl_client.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -33,9 +33,10 @@
 extern int ssl_errno;
 
-typedef void (*SslInputFunction)(gpointer, void*, GaimInputCondition);
+typedef void (*ssl_input_function)(gpointer, void*, GaimInputCondition);
 
-G_MODULE_EXPORT void *ssl_connect( char *host, int port, SslInputFunction func, gpointer data );
+G_MODULE_EXPORT void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data );
 G_MODULE_EXPORT int ssl_read( void *conn, char *buf, int len );
 G_MODULE_EXPORT int ssl_write( void *conn, const char *buf, int len );
 G_MODULE_EXPORT void ssl_disconnect( void *conn_ );
 G_MODULE_EXPORT int ssl_getfd( void *conn );
+G_MODULE_EXPORT GaimInputCondition ssl_getdirection( void *conn );
Index: protocols/ssl_gnutls.c
===================================================================
--- protocols/ssl_gnutls.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/ssl_gnutls.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -38,5 +38,5 @@
 struct scd
 {
-	SslInputFunction func;
+	ssl_input_function func;
 	gpointer data;
 	int fd;
@@ -51,5 +51,5 @@
 
 
-void *ssl_connect( char *host, int port, SslInputFunction func, gpointer data )
+void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data )
 {
 	struct scd *conn = g_new0( struct scd, 1 );
@@ -111,5 +111,8 @@
 	
 	if( conn->inpa != -1 )
+	{
 		gaim_input_remove( conn->inpa );
+		conn->inpa = -1;
+	}
 	
 	if( ( st = gnutls_handshake( conn->session ) ) < 0 )
@@ -117,7 +120,5 @@
 		if( st == GNUTLS_E_AGAIN || st == GNUTLS_E_INTERRUPTED )
 		{
-			conn->inpa = gaim_input_add( conn->fd,
-			                             gnutls_record_get_direction( conn->session ) ?
-			                                 GAIM_INPUT_WRITE : GAIM_INPUT_READ,
+			conn->inpa = gaim_input_add( conn->fd, ssl_getdirection( conn ),
 			                             ssl_handshake, data );
 		}
@@ -145,4 +146,6 @@
 int ssl_read( void *conn, char *buf, int len )
 {
+	int st;
+	
 	if( !((struct scd*)conn)->established )
 	{
@@ -151,10 +154,17 @@
 	}
 	
-	return( gnutls_record_recv( ((struct scd*)conn)->session, buf, len ) );
-	
+	st = gnutls_record_recv( ((struct scd*)conn)->session, buf, len );
+	
+	ssl_errno = SSL_OK;
+	if( st == GNUTLS_E_AGAIN || st == GNUTLS_E_INTERRUPTED )
+		ssl_errno = SSL_AGAIN;
+	
+	return st;
 }
 
 int ssl_write( void *conn, const char *buf, int len )
 {
+	int st;
+	
 	if( !((struct scd*)conn)->established )
 	{
@@ -163,5 +173,11 @@
 	}
 	
-	return( gnutls_record_send( ((struct scd*)conn)->session, buf, len ) );
+	st = gnutls_record_send( ((struct scd*)conn)->session, buf, len );
+	
+	ssl_errno = SSL_OK;
+	if( st == GNUTLS_E_AGAIN || st == GNUTLS_E_INTERRUPTED )
+		ssl_errno = SSL_AGAIN;
+	
+	return st;
 }
 
@@ -169,4 +185,7 @@
 {
 	struct scd *conn = conn_;
+	
+	if( conn->inpa != -1 )
+		gaim_input_remove( conn->inpa );
 	
 	if( conn->established )
@@ -184,2 +203,8 @@
 	return( ((struct scd*)conn)->fd );
 }
+
+GaimInputCondition ssl_getdirection( void *conn )
+{
+	return( gnutls_record_get_direction( ((struct scd*)conn)->session ) ?
+	        GAIM_INPUT_WRITE : GAIM_INPUT_READ );
+}
Index: protocols/ssl_nss.c
===================================================================
--- protocols/ssl_nss.c	(revision 3e91c3ec7d6426c4c2819e78275f935e1a7fce2c)
+++ protocols/ssl_nss.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
@@ -45,5 +45,5 @@
 struct scd
 {
-	SslInputFunction func;
+	ssl_input_function func;
 	gpointer data;
 	int fd;
@@ -91,5 +91,5 @@
 
 
-void *ssl_connect( char *host, int port, SslInputFunction func, gpointer data )
+void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data )
 {
 	struct scd *conn = g_new0( struct scd, 1 );
